.module macros_entidad.h.s
;;macros para manejo de entidad
.include "macros_struct.h.s"
;;declaracion entidad
;;input Define_entidad x,y
.macro Define_Entidad _nombre,_cmp,_x,_y,_ancho,_alto,_sprite,_status,_patrol
	_nombre::
	.db _cmp		;;componente bitfield entidad
	.db _x
	.db _y
	.db _ancho
	.db _x+_ancho	;;derecha de entidad
	.db _alto
	.db _y+_alto	;;abajo de entidad
	.db 0
	.db 0
	.dw 0xc000
	.dw 0xc000
	.dw _sprite
	.db _status			;;status entidad 
	.db _status			;;status previo
	.db 0,0			;;objetivo x,y
	.dw _patrol		;;patrol array de XY
	.db 0
.endm
;;definicion creacion Entidaddes
BeginStruct 	Ent 
	StructField 	Ent,cmp,	1	;;Ent_cmp		=0
	StructField 	Ent,x,		1	;;Ent_x			=1
	StructField 	Ent,y,		1	;;Ent_y			=2
	StructField		Ent,ancho,	1	;;ent_alto 		=3
	StructField		Ent,derecha,1	;;x+ancho
	StructField		Ent,alto,	1	;;ent_ancho		=4
	StructField		Ent,abajo,	1	;;y+alto
	StructField 	Ent,vx 	,	1	;;ent_vx		=5
	StructField 	Ent,vy,		1	;;Ent_vy		=6
	StructField 	Ent,newmem,	2
	StructField		Ent,oldmem,	2
	StructField		Ent,sprite,	2	;;Ent_sprite +0 + 1
	StructField 	Ent,status,	1	;;Ent_status
	StructField		Ent,prev_st,1	;;ent status previo
	StructField		Ent,obj_x,	1	;;objetivo X
	StructField		Ent,obj_y,	1	;;objetivo y
	StructField		Ent,p_step,	2	;;patrol step
	StructField		Ent,spr_turno,1	;;turno de animacion del Sprite
EndStruct		Ent

;;definicion mascara entidad
BeginbitField	Ent
	BitField 		Ent,tesoro
	BitField 		Ent,fisica
	BitField 		Ent,render
	BitField 		Ent,IA
	BitField 		Ent,colisionable
	BitField 		Ent,solido
	BitField 		Ent,enemigo
EndBitField 	Ent   		
;;control de IA por compnente
ent_sin_IA		= 0
ent_stand_by	= 1
ent_moving_to	= 2
ent_checking	= 3
ent_patrol		= 4

Ent_jugador 	= (Ent_colisionable_mask | Ent_fisica_mask | Ent_render_mask )
Ent_enemigo		= (Ent_enemigo_mask | Ent_colisionable_mask | Ent_fisica_mask | Ent_render_mask | Ent_IA_mask )
Ent_decorado	= (Ent_render_mask | Ent_colisionable_mask)
Ent_obstaculo 	= (Ent_colisionable_mask | Ent_render_mask | Ent_solido_mask)
Ent_tesoro		= (Ent_tesoro_mask | Ent_colisionable_mask | Ent_fisica_mask | Ent_render_mask | Ent_IA_mask )
maximo_Ent = 10

;;macro declaracion array entidades
;;input Define_struc_Array nombre de array, numero de veces a repetir
;;salida pej: array_PEnd como pùntero a primera entidad libre
;;array_array: nombre de array publico
.macro Define_Struct_Array nombre,repeticion
	nombre'_PEnd::	.dw nombre'_struct_array
	nombre'_struct_array::
		.rept repeticion
			.ds sizeof_Ent
		.endm
.endm
;;macro declaracion para hacer array de punteros
;;pej: array de enemigos: 0x1000,0x1010,0x1020...
;;input nombre de array, numero de punteros
.macro Define_Puntero_Array nombre,repeticion
	nombre'_PEnd:: .dw nombre'_Puntero_array
	nombre'_Puntero_array::
		.rept repeticion
			.dw 0x0000
		.endm
.endm

