.module manager_entidades.s

.include "macros_entidad.h.s"
.include "entidades.h.s"
;;===================================================
;;Definiciones de entidades a usar en el juego
;; nombre de macro: nombre_entidad
;; tipo_entidad,x,y,ancho,alto,velocidad x,y,posicion_memoria,sprite
;;===================================================
Define_Entidad jugador Ent_jugador,10,184,6,16,_jugador_derecha,ent_sin_IA,patrol_0
Define_Entidad enemigo Ent_enemigo,20,20,6,12,_fantasma,ent_stand_by,patrol_1
Define_Entidad escalera	Ent_enemigo,30,30,4,8,_blob,ent_stand_by,patrol_0
Define_Entidad serpiente Ent_enemigo,30,40,4,8,_serpiente_derecha,ent_stand_by,patrol_2
Define_Entidad ladrillo Ent_enemigo,20,80,4,8,_ladrillo,ent_stand_by,patrol_0
Define_Entidad moneda Ent_tesoro,10,1,4,8,_coin,ent_stand_by,patrol_0
Define_Entidad hormigon Ent_enemigo,20,80,4,8,_hormigon,ent_stand_by,patrol_0
Define_Entidad pato_derecha Ent_enemigo,20,80,4,8,_pato_derecha,ent_stand_by,patrol_0
Define_Entidad barrotes Ent_enemigo,20,80,4,8,_barrotes,ent_stand_by,patrol_0
Define_Entidad calavera Ent_enemigo,20,80,4,8,_calavera,ent_stand_by,patrol_0
Define_Entidad hierba Ent_enemigo,20,80,4,8,_hierba,ent_stand_by,patrol_0



;;====================================================
;;definicon array entidades
;;creacion etiquetas: Entidades_struct_array y Entidades_PEnd
;;====================================================
Define_Struct_Array Entidades, maximo_Ent
;;====================================================
;;pone la primera entidad libre al principio del array
;;====================================================
reset_entities::
	ld hl,#Entidades_struct_array
	ld (Entidades_PEnd),hl
ret
;;====================================================
;;pone a 0 todo el array proporcionado
;;input hl como array
;;destruye Hl,de,bc,af
;;====================================================
reset_array::
	ld hl,#Entidades_struct_array	;;HL=&array de entidades
	ld a,#0 		;;A=0
	ld (hl),a 		;;(HL)=0
	ld d,h 			;;DE=hl
	ld e,l
	inc de 			;;DE++
	ld bc,#(sizeof_Ent* maximo_Ent)-1 ;;bc=tamaño array-1
	ldir
ret 
;;====================================================
;;llama a añadir puntero segun el componente entidad
;;input ix como entiadad
;;altera af
;;====================================================
componente_entidad::
	ld a,Ent_cmp(ix) 					;;A=tipo entidad
		and #Ent_render_mask				;;es pintable?
		call nz,añade_puntero_render	;;si, añade puntero
	
	ld a,Ent_cmp(ix) 					;;A=tipo entidad
	and #Ent_fisica_mask 				;;tiene fisica?
		call nz,añade_puntero_fisica	;;añade puntero a fisica

	ld a,Ent_cmp(ix) 					;;A=tipo entidad
	and #Ent_IA_mask 					;;tiene IA?
		call nz,añade_puntero_IA		;;añade puntero a IA
	ld a,Ent_cmp(ix)
	and #Ent_colisionable_mask
		call nz,añade_puntero_colision
		
ret