.module manager_juego.s
.include "cpctelera.h.s"
.include "juego.h.s"
.globl eleccion_pantalla
;;================================================
;;pone arrays a valor por defecto
;;llama a creacion de pantalla inicial
;;================================================
inicia_juego::
	ld c,#0
	call cpct_setVideoMode_asm		;;mode 0
	call reset_systems				;;reset sistemas
	call init_systems				;;inicia sistemas

	call sys_menu 					;;menu principal
	call eleccion_pantalla					;;comienza juego
ret
;;================================================
;;hace un bucle con las actuializaciones del juego
;;================================================
actualiza_juego::
	cpctm_setBorder_asm HW_CYAN
	call render_update			;;pinta todos los sprites
	cpctm_setBorder_asm HW_PINK
	call input
	cpctm_setBorder_asm HW_GREEN
	call ia_update				;;actualiza patron enenmigo
	cpctm_setBorder_asm HW_BLACK
	call sys_colision_update	;;compruebga colisiones entre todos
		ld ix,#Entidades_struct_array
	cpctm_setBorder_asm HW_YELLOW
	call animation_update		;;actualiza animacion sprite
	cpctm_setBorder_asm HW_WHITE
	call fisica_update			;;actualiza la fisica de entidades
	cpctm_setBorder_asm HW_BLUE


		call cpct_waitVSYNC_asm	;;espera barrido horizontal
ret
reset_systems:
	call reset_array				;;array puesto por defecto
	call reset_entities				;;puntero nueva entidad al array
	call reset_ptr_render 			;;reset array de render
	call reset_ptr_fisica			;;reset array de fisica
	call reset_ptr_colision
	call reset_pantalla
ret
init_systems:
	call render_sys_init		;;reset array de render
	call fisica_init			;;inicia sistema de fisica
	call sys_colision_init		;;inicia sistema de colisiones	
	call ia_init				;;inicia sistema IA
ret
;;pone as 0 pantalla, puntos
reset_pantalla:
	ld a,#0
	ld (puntos),a
	ld (pantalla),a
ret