.module sys_colision
.include "cpctelera.h.s"
.include "macros_entidad.h.s"

.globl sys_check_collision
.globl colision_Puntero_array
.globl Entidades_struct_array
.globl contra_que_choca
;;guarda en memoria el puntero de colisiones
sys_colision_init::
	ld hl,#Entidades_struct_array
	ld (primera_entidad),hl 	;;ix=1a entidad
	ld bc,#sizeof_Ent
	add hl,bc
	ld (segunda_entidad),hl 	;;iy=2a ENTIDAD
ret
;;actualiza y compara entidades
sys_colision_update::
	primera_entidad = .+2		;;primera entidad=ix
	ld ix,#0x0000
	segunda_entidad = .+2	;segunda entidad=iy
	ld iy,#0x0000
loop_colision:
	;;comprueba que entidad es valida
	;;si encho entidad =0 vuelve
	ld a,Ent_ancho(ix)
	cp #0
		ret z	;;A==0?vuelve
	call loop_IY
	ld bc,#sizeof_Ent	;;BC=tamaño entidad
	add ix,BC 			;;ix+=bc, siguiente entidad ix
	
	ld__ix_iy

	ld bc,#sizeof_Ent 	;;bc=tamaño entidad
	add iy,bc 			;;siguiente entidad iy
	jp loop_colision
;; comprobacion de IX vs demas entidades (iy)	
loop_IY:	
	ld a,Ent_ancho(iy)	;;A=ancho entidad
	cp #0
		ret z			;;si a==0 vuelve
	;call sys_check_collision	;;funcion colision
sys_check_collision:
;;if b<c no colision
	ld a,Ent_derecha(ix)			;;A=X.ix
	;dec a
	sub Ent_x(iy)			;;A-=x.iy
		jr c,no_hay_colision	;;NO HAY COLIsion?salta
;;if d<b
	ld a,Ent_x(iy)			;;A=x.iy
	dec a
	add Ent_ancho(iy)		;;a+=ancho.iy
	sub Ent_x(ix)			;;A-=x.ix
		jr c,no_hay_colision
;;if b<c no colision (vertical)
	ld a,Ent_y(ix)
	dec a
	add Ent_alto(ix)
	sub Ent_y(iy)
		jr c,no_hay_colision
;;id d<b(vertical)
	ld a,Ent_y(iy)
	dec a
	add Ent_alto(iy)
	sub Ent_y(ix)
		jr c,no_hay_colision    
colision:  
	cpctm_setBorder_asm #HW_LIME
	call contra_que_choca
	jp siguiente_entidad_iy
;;no hay colision
no_hay_colision:

siguiente_entidad_iy:
	ld bc,#sizeof_Ent	;iy+=tamaño entidad
	add iy,BC 			;;siguiente entidad
	jp loop_IY			;;loop entidad iY
ret	