.module control_ia
.globl IA_Puntero_array
.globl IA_update_entity
.globl doit_for_all
.globl ent_moving_to
.globl Entidades_struct_array
.globl ia_patrol
.globl ia_patrol_step
.globl man_patrol_getter
.include "macros_entidad.h.s"
;;================================================
;;comprueba estado de IA, llama a rutina segun el estado
;;cambia el estado de entidad
;;input ix puntero entidad iy como jugador
;;
;;altera AF,hl,de
;;================================================
IA_update_entity:
	;call ia_patrol_step
	;ld Ent_p_step+0(ix),l 		;;SIGUIENTE TURNO DE PATRULLA
	;ld Ent_p_step+1(ix),h
	ld a,Ent_status(ix)		;;A=status entidad
	ld b,a
	cp #ent_stand_by
		jp z,entidad_stand_by
	ld a,b	;;A=status entidad
	cp #ent_checking
		jp z,checking
	ld a,b
	cp #ent_moving_to
		 jp z,move_to
	ld a,b
	cp #ent_patrol
		jp z,ia_patrol
ret

ia_init::
	ld hl,#IA_Puntero_array	;;pone el inicio de array
	ld (array_update_IA),hl	;;en el update para su uso
	ld hl,#Entidades_struct_array
	ld (puntero_jugador),hl
	ld (puntero_jugador_2),hl
	ret
ia_update::
	array_update_IA= .+1	;;inicio array ia
	ld de,#0x0000				;;puntero a array ia
	ld hl,#IA_update_entity ;;HL=&funcion update
	call doit_for_all 			;;llama a funcion doit para procesamiento
ret
;;accion si entidad no tiene ia
entidad_sin_IA::
ret
;;cambia velocidad entidad y estado a moving 
;; velocidades estables mientras no hay cambios
;;altera HL,AF
entidad_stand_by::

	ld Ent_vx(ix),#0		;;velocidad estable
	ld Ent_vy(ix),#0
	ld a,Ent_status(ix)
	ld Ent_prev_st(ix),a
	ld Ent_status(ix),#ent_patrol	;ent_checking ;cambia estado,no entra aqui ahora

ret
;;comprueba si entidad jugador tiene estado de perseguido
;;si esta activo, cambia a jugador como objetivo
;;altera velocidades de entidad
checking::

	puntero_jugador= .+2		;;IY=entidad jugador
	ld iy,#0x0000
	ld a,Ent_status(iy) 		;;A=status jugador
	or a 						;;si a=0, vuelve
	ret z

	;;cambia objetivo XY de entidad a las actuales de jugador
	ld a,Ent_x(iy)				;;A=x.jugador
	ld Ent_obj_x(ix),a 			;;obj_x=A

	ld a,Ent_y(iy)				;;A=y.jugador
	ld Ent_obj_y(ix),a			;;obj.y.entidad=a

	ld Ent_status(ix), #ent_moving_to	;;cambia estado entidad
ret
;;cambia velocidades de entidad hasta llegar a destino
;; entonces cambia a 0
move_to::
	ld Ent_vx(ix),#0	;;VX=0
	ld a,Ent_obj_x(ix)		;;A=objetivo x
	sub Ent_x(ix) 		;;a-=X
	jr nc,obj_x_mayor_o_igual 	;;compara a con objetivo
obj_menor_que::
	ld Ent_vx(ix),#-1		;;velocidad x =-1
	jr end_if_x				;;salta
obj_x_mayor_o_igual::
	jr z,llegado_x			;;if z=0 , ha llegado,salta
	ld Ent_vx(ix),#1 		;;vel x = 1
	jr end_if_x				;;salta
llegado_x:
	ld Ent_vx(ix),#0		;;vel x = 0
end_if_x::
	ld Ent_vy(ix),#0 		;;vel y = 0
	ld a,Ent_obj_y(ix) 		;;A=obj y
	sub Ent_y(ix) 			;;resta y
	jr nc,obj_y_mayor_o_igual 	;;comparacion 
obj_y_menor_que:
	ld Ent_vy(ix),#-1		;;vel y =-1
	jr end_if_y				;;salta
obj_y_mayor_o_igual:
	jr z,llegado_y			;;si a=0, salta
	ld Ent_vy(ix),#1		;;vel y = 1
	jr end_if_y
llegado_y::
	ld Ent_vy(ix),#0		;;vel y =0
	ld a,Ent_vx(ix)			;;A=vel.x
	or a 					;;A=0?
	jr nz,end_if_y			;;a<>0,salta
	;;entidad ha llegado a objetivo, cambia estado
	;;anterior 
	;;estado actual cambia a stand_by
		;ld a,Ent_prev_st(ix)	;;a=status previo
		;ld Ent_status(ix),a 	;;status = a
		ld Ent_prev_st(ix),#ent_moving_to ;;st previo = moving
		ld Ent_status(ix),#ent_stand_by
		puntero_jugador_2= .+2		;;IY=entidad jugador
			ld iy,#0x0000
end_if_y:
	
ret
